//+------------------------------------------------------------------+
//|                                           EARopebyEricNaiman.mq5 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property description "EARopebyEricNaiman by Im_hungry (https://login.mql5.com/en/users/Im_hungry)"
#property version   "1.00"
#property strict
//---
enum ENUM_TRADEMODEOPEN
  {
   //---     0 /   - ,   - 
   m1=0,// main line cross zero
   //---       /     ()      ()
   m2=1,// main line color
   //---         /       - ,   - 
   m3=2,// main line cross MAfast
   //---      /        - ,   - 
   m4=3,// two MA cross
  };
//---
input string section_1="___ Main settings";
//---   
input ENUM_TRADEMODEOPEN trade_mode=m4;
input double Lot=0.1;
input int StopLoss=2200;
input int TakeProfit=4000;
input int Slippage=20;
input int MagicNumber=12345;
//---  
input string section_2="___ RopebyEricNaiman settings";
input int _period=76;
input ENUM_APPLIED_PRICE _price=PRICE_CLOSE;
input string section_3="___ MA by RopebyEricNaiman fast";
input int period_MA_fast=25;
input ENUM_MA_METHOD method_MA_fast=MODE_SMA;
input string section_4="___ MA by RopebyEricNaiman slow";
input int period_MA_slow=143;
input ENUM_MA_METHOD method_MA_slow=MODE_SMA;
//---   
input string section_5="___ Close settings";
//---        /  BUY       
input bool close1=true; // Close main line cross zero
//---         /  BUY     
input bool close2=false; // Close main line color
//---        /  BUY        
input bool close3=false; // Close main line cross MAfast
//---       /  BUY         
input bool close4=true; // Close two MA cross
//---- buffers
datetime _tm;
datetime _arr_time[];
double open;
double Ptr;
double _point;
string _symbol;
string _str_close;
int RbEN_handle;
int rule_1;
int type;
int _digits;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   _symbol=Symbol();
   _digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
   _point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
//---
   ResetLastError();
   RbEN_handle=iCustom(_symbol,PERIOD_CURRENT,"RopebyEricNaiman",
                       "",
                       false,
                       true,
                       _period,
                       _price,
                       1000,
                       1,
                       "",
                       ((trade_mode==2 || trade_mode==3)?true:false),
                       period_MA_fast,
                       method_MA_fast,
                       "",
                       (trade_mode==3?true:false),
                       period_MA_slow,
                       method_MA_slow);
   if(RbEN_handle==INVALID_HANDLE)
     {
      Print("Error loading RopebyEricNaiman: "+(string)GetLastError()," | symbol: ",Symbol());
      ExpertRemove();
      return INIT_FAILED;
     }
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   int copy=Copy_Time(_arr_time,_symbol,_Period,0,1);
   if(copy!=1)
     {
      Print(__FUNCTION__+"/ Error (",GetLastError(),") Copy Time : ",copy," | _symbol: ",_symbol);
     }
//---     
   if(_tm<_arr_time[0])
     {
      _tm=_arr_time[0];
      //---          
      if(!PositionSelect(_symbol))
        {
         rule_1=Check_Indi_Open();
         datetime now=TakeLastOpenTime(_symbol);
         if(rule_1>2) _tm=0;
         if(rule_1<=1 && _arr_time[0]>now)
           {
            OpenPosition(rule_1,_symbol,Lot,"main");
            _tm=0;
           }
        }
      //---         
      else
        {
         type=(int)PositionGetInteger(POSITION_TYPE);
         open=PositionGetDouble(POSITION_PRICE_OPEN);
         Ptr=PositionGetDouble(POSITION_VOLUME);
         if(close1 || close2 || close3 || close4)
           {
            rule_1=Check_Indi_Close();
            if(rule_1>2) _tm=0;
            if(rule_1!=type && rule_1<2)
              {
               Print("Started closing position ("+_str_close+") at : ",_symbol," | type : ",(type==0?"BUY":"SELL")," | price : ",DoubleToString(open,_digits)+" | lot : ",DoubleToString(Ptr,_digits));
               CloseAllPosition(_symbol,_str_close);
               _tm=0;
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| Check_Indi_Open                                                  |
//+------------------------------------------------------------------+
int Check_Indi_Open()
  {
//---      
   int copy=0;
   double _arr_ind_1[];
   double mafast[];
   double mainline[];
   double maslow[];
//---    switch        trade_mode
   switch((int)trade_mode)
     {
      case 0:
         //---        ,   
         copy=Copy_indi_Buffer(RbEN_handle,4,1,2,_arr_ind_1,"RbEN");
         if(copy!=2) return 4;
         if(_arr_ind_1[0]!=EMPTY_VALUE && _arr_ind_1[1]!=EMPTY_VALUE && 
            _arr_ind_1[0]>0 && _arr_ind_1[1]<=0)
           {
            return 0;
           }
         if(_arr_ind_1[0]!=EMPTY_VALUE && _arr_ind_1[1]!=EMPTY_VALUE && 
            _arr_ind_1[0]<0 && _arr_ind_1[1]>=0)
           {
            return 1;
           }
         break;
      case 1:
         //---        5    ,   
         copy=Copy_indi_Buffer(RbEN_handle,5,1,2,_arr_ind_1,"RbEN");
         if(copy!=2) return 5;
         if(_arr_ind_1[0]!=EMPTY_VALUE && _arr_ind_1[1]!=EMPTY_VALUE && 
            _arr_ind_1[0]==0 && _arr_ind_1[1]!=0)
           {
            return 0;
           }
         if(_arr_ind_1[0]!=EMPTY_VALUE && _arr_ind_1[1]!=EMPTY_VALUE && 
            _arr_ind_1[0]==1 && _arr_ind_1[1]!=1)
           {
            return 1;
           }
         break;
      case 2:
         //---      mafast (    )  mainline (  )    ,   
         copy=Copy_indi_Buffer(RbEN_handle,6,1,2,mafast,"RbEN");
         if(copy!=2) return 6;
         copy=Copy_indi_Buffer(RbEN_handle,4,1,2,mainline,"RbEN");
         if(copy!=2) return 7;
         if(mafast[0]!=EMPTY_VALUE && mafast[1]!=EMPTY_VALUE && 
            mainline[0]!=EMPTY_VALUE && mainline[1]!=EMPTY_VALUE && 
            mainline[0]>mafast[0] && mainline[1]<=mafast[1])
           {
            return 0;
           }
         if(mafast[0]!=EMPTY_VALUE && mafast[1]!=EMPTY_VALUE && 
            mainline[0]!=EMPTY_VALUE && mainline[1]!=EMPTY_VALUE && 
            mainline[0]<mafast[0] && mainline[1]>=mafast[1])
           {
            return 1;
           }
         break;
      case 3:
         //---     mafast (     )  maslow (     )    ,   
         copy=Copy_indi_Buffer(RbEN_handle,6,1,2,mafast,"RbEN");
         if(copy!=2) return 8;
         copy=Copy_indi_Buffer(RbEN_handle,7,1,2,maslow,"RbEN");
         if(copy!=2) return 9;
         if(mafast[0]!=EMPTY_VALUE && mafast[1]!=EMPTY_VALUE &&
            maslow[0]!=EMPTY_VALUE && maslow[1]!=EMPTY_VALUE &&
            maslow[0]<mafast[0] && maslow[1]>=mafast[1])
           {
            return 0;
           }
         if(mafast[0]!=EMPTY_VALUE && mafast[1]!=EMPTY_VALUE &&
            maslow[0]!=EMPTY_VALUE && maslow[1]!=EMPTY_VALUE &&
            maslow[0]>mafast[0] && maslow[1]<=mafast[1])
           {
            return 1;
           }
         break;
      default: return 3;
     }
//---
   return 2;
  }
//+------------------------------------------------------------------+
//| Check_Indi_Close                                                 |
//+------------------------------------------------------------------+
int Check_Indi_Close()
  {
//---      
   int copy=0;
   double _arr_ind_1[];
   double mafast[];
   double mainline[];
   double maslow[];
   _str_close="";
//---            ,   
   if(close1)
     {
      copy=Copy_indi_Buffer(RbEN_handle,4,1,2,_arr_ind_1,"RbEN");
      if(copy!=2) return 4;
      _str_close="Close main line cross zero";
      if(_arr_ind_1[0]!=EMPTY_VALUE && _arr_ind_1[1]!=EMPTY_VALUE && 
         _arr_ind_1[0]>0 && _arr_ind_1[1]<=0)
        {
         return 0;
        }
      if(_arr_ind_1[0]!=EMPTY_VALUE && _arr_ind_1[1]!=EMPTY_VALUE && 
         _arr_ind_1[0]<0 && _arr_ind_1[1]>=0)
        {
         return 1;
        }
     }
//---        5    ,   
   if(close2)
     {
      copy=Copy_indi_Buffer(RbEN_handle,5,1,2,_arr_ind_1,"RbEN");
      if(copy!=2) return 5;
      _str_close="Close main line color";
      if(_arr_ind_1[0]!=EMPTY_VALUE && _arr_ind_1[1]!=EMPTY_VALUE && 
         _arr_ind_1[0]==0 && _arr_ind_1[1]!=0)
        {
         return 0;
        }
      if(_arr_ind_1[0]!=EMPTY_VALUE && _arr_ind_1[1]!=EMPTY_VALUE && 
         _arr_ind_1[0]==1 && _arr_ind_1[1]!=1)
        {
         return 1;
        }
     }
//---      mafast (    )  mainline (  )    ,   
   if(close3)
     {
      copy=Copy_indi_Buffer(RbEN_handle,6,1,2,mafast,"RbEN");
      if(copy!=2) return 6;
      copy=Copy_indi_Buffer(RbEN_handle,4,1,2,mainline,"RbEN");
      if(copy!=2) return 7;
      _str_close="Close main line cross MAfast";
      if(mafast[0]!=EMPTY_VALUE && mafast[1]!=EMPTY_VALUE && 
         mainline[0]!=EMPTY_VALUE && mainline[1]!=EMPTY_VALUE && 
         mainline[0]>mafast[0] && mainline[1]<=mafast[1])
        {
         return 0;
        }
      if(mafast[0]!=EMPTY_VALUE && mafast[1]!=EMPTY_VALUE && 
         mainline[0]!=EMPTY_VALUE && mainline[1]!=EMPTY_VALUE && 
         mainline[0]<mafast[0] && mainline[1]>=mafast[1])
        {
         return 1;
        }
     }
//---     mafast (     )  maslow (     )    ,   
   if(close4)
     {
      copy=Copy_indi_Buffer(RbEN_handle,6,1,2,mafast,"RbEN");
      if(copy!=2) return 8;
      copy=Copy_indi_Buffer(RbEN_handle,7,1,2,maslow,"RbEN");
      if(copy!=2) return 9;
      _str_close="Close two MA cross";
      if(mafast[0]!=EMPTY_VALUE && mafast[1]!=EMPTY_VALUE &&
         maslow[0]!=EMPTY_VALUE && maslow[1]!=EMPTY_VALUE &&
         maslow[0]<mafast[0] && maslow[1]>=mafast[1])
        {
         return 0;
        }
      if(mafast[0]!=EMPTY_VALUE && mafast[1]!=EMPTY_VALUE &&
         maslow[0]!=EMPTY_VALUE && maslow[1]!=EMPTY_VALUE &&
         maslow[0]>mafast[0] && maslow[1]<=mafast[1])
        {
         return 1;
        }
     }
//---
   return 2;
  }
//+------------------------------------------------------------------+
//| Copy_indi_Buffer                                                 |
//+------------------------------------------------------------------+
int Copy_indi_Buffer(int handle,
                     int IB,
                     int shift,
                     int size,
                     double &arr_ind[],
                     string comm)
  {
   ArrayResize(arr_ind,size);
   ArrayInitialize(arr_ind,0.0);
   ArraySetAsSeries(arr_ind,true);
   int copy=CopyBuffer(handle,IB,shift,size,arr_ind);
   if(copy<=0)
     {
      Sleep(100);
      for(int i=0; i<100; i++)
        {
         if(BarsCalculated(handle)>0) break;
         Sleep(50);
        }
      copy=CopyBuffer(handle,IB,shift,size,arr_ind);
     }
   if(copy!=size)
     {
      Alert("Indicator "+comm+" copy data error(",GetLastError(),")");
      return 0;
     }
   return copy;
  }
//+------------------------------------------------------------------+
//| TakeLastOpenTime                                                 |
//+------------------------------------------------------------------+
datetime TakeLastOpenTime(string ch_symbol)
  {
   if(!PositionSelect(ch_symbol))
     {
      uint ch_total=0;
      ulong ch_ticket;
      bool res=HistorySelect(0,TimeCurrent());
      ch_total=HistoryDealsTotal()-1;
      if(!res)
        {
         Print(__FUNCTION__+"\\ Wrong HistorySelect | total: ",ch_total);
        }
      for(int k=(int)ch_total; k>=0; k--)
        {
         ch_ticket=HistoryDealGetTicket(k);
         if(ch_ticket>0)
           {
            //---
           }
         else
           {
            continue;
           }
         if(ch_symbol==HistoryDealGetString(ch_ticket,DEAL_SYMBOL) && 
            HistoryDealGetInteger(ch_ticket,DEAL_ENTRY)==DEAL_ENTRY_IN)
           {
            return (datetime)HistoryDealGetInteger(ch_ticket,DEAL_TIME);
           }
        }
     }
   return 0;
  }
//+------------------------------------------------------------------+
//| OpenPosition                                                     |
//+------------------------------------------------------------------+
bool OpenPosition(int type_i,
                  string p_symbol,
                  double Lt,
                  string cmm)
  {
   MqlTradeRequest mrequest;
   MqlTradeResult mresult;
   ZeroMemory(mrequest);
   mrequest.action    = TRADE_ACTION_DEAL;
   mrequest.symbol    = p_symbol;
   mrequest.volume    = NormalizeDouble(Lt,2);
   mrequest.magic     = MagicNumber;
   mrequest.deviation = Slippage;
   mrequest.comment   = cmm;
   if(type_i==0)
     {
      mrequest.type    = ORDER_TYPE_BUY;
      mrequest.price   = NormalizeDouble(SymbolInfoDouble(_symbol,SYMBOL_ASK),_digits);
      mrequest.sl      = NormalizeDouble((StopLoss>0?(mrequest.price-(StopLoss*_point)):0.0),_digits);
      mrequest.tp      = NormalizeDouble((TakeProfit>0?(mrequest.price+(TakeProfit*_point)):0.0),_digits);
     }
   if(type_i==1)
     {
      mrequest.type    = ORDER_TYPE_SELL;
      mrequest.price   = NormalizeDouble(SymbolInfoDouble(_symbol,SYMBOL_BID),_digits);
      mrequest.sl      = NormalizeDouble((StopLoss>0?(mrequest.price+(StopLoss*_point)):0.0),_digits);
      mrequest.tp      = NormalizeDouble((TakeProfit>0?(mrequest.price-(TakeProfit*_point)):0.0),_digits);
     }
//---
   Print("Started opening position at: ",p_symbol," | type: ",(type_i==0?"BUY":"SELL")," | price: ",DoubleToString(mrequest.price,_digits)+
         " | lot: ",DoubleToString(Lt,_digits)," | SL: ",DoubleToString(mrequest.sl,_digits)," | TP: ",DoubleToString(mrequest.tp,_digits));
   if(!OrderSend(mrequest,mresult))
     {
      Print("Error opening position | comment : ",mresult.comment," | answer code : ",mresult.retcode);
      return false;
     }
   else
     {
      Print("Successful sending request (opening position) to the server");
      Print(" retcode=",mresult.retcode,
            " | deal=",mresult.deal,
            " | order=",mresult.order,
            " | volume=",DoubleToString(mresult.volume,2),
            " | price=",DoubleToString(mresult.price,_digits),
            " | bid=",DoubleToString(mresult.bid,_digits),
            " | ask=",DoubleToString(mresult.ask,_digits),
            " | comment=",mresult.comment,
            " | request_id=",mresult.request_id);
      if(mresult.deal==0 && mresult.order==0)
        {
         Alert(__FUNCTION__+"/ MqlTradeResult Error to get deal ("+(string)mresult.deal+")\\order "+(string)mresult.order+") \\ open lost");
        }
      return true;
     }
   return false;
  }
//+------------------------------------------------------------------+
//| Copy_Time                                                        |
//+------------------------------------------------------------------+
int Copy_Time(datetime &arr_time[],
              string symbol,
              ENUM_TIMEFRAMES tf,
              int shift,
              int size)
  {
   ArrayResize(arr_time,size);
   ArrayInitialize(arr_time,0.0);
   ArraySetAsSeries(arr_time,true);
   int copy=CopyTime(symbol,tf,shift,size,arr_time);
   if(copy!=size)
     {
      Print(__FUNCTION__+"/ Error ("+(string)GetLastError()+") Copy Time : "+(string)copy," | symbol: ",symbol);
      ArrayInitialize(arr_time,0);
      return 0;
     }
   else
     {
      return copy;
     }
   return 0;
  }
//+------------------------------------------------------------------+
//| CloseAllPosition                                                 |
//+------------------------------------------------------------------+
int CloseAllPosition(string p_symbol,string comm)
  {
   MqlTradeRequest mrequest;
   MqlTradeResult mresult;
   ZeroMemory(mrequest);
   if(PositionSelect(p_symbol))
     {
      type=(int)PositionGetInteger(POSITION_TYPE);
      mrequest.action    = TRADE_ACTION_DEAL;
      mrequest.price     = type==0?SymbolInfoDouble(_symbol,SYMBOL_BID):SymbolInfoDouble(_symbol,SYMBOL_ASK);
      mrequest.symbol    = p_symbol;
      mrequest.volume    = PositionGetDouble(POSITION_VOLUME);
      mrequest.magic     = PositionGetInteger(POSITION_MAGIC);
      mrequest.type      = type==0?ORDER_TYPE_SELL:ORDER_TYPE_BUY;
      mrequest.deviation = Slippage;
      mrequest.comment   = comm;
      Print("Started closing position at: ",p_symbol," | type: ",(type==0?"BUY":"SELL")," | price: ",DoubleToString(mrequest.price,_digits)+
            " | lot: ",DoubleToString(mrequest.volume,_digits)," | SL: ",DoubleToString(mrequest.sl,_digits)," | TP: ",DoubleToString(mrequest.tp,_digits));
      if(!OrderSend(mrequest,mresult))
        {
         Print("Error close position | comment : ",mresult.comment," | answer code : ",mresult.retcode," | symbol: ",p_symbol);
         return 0;
        }
      else
        {
         Print("Successful sending request (closing position) to the server");
         Print(" retcode=",mresult.retcode,
               " | deal=",mresult.deal,
               " | order=",mresult.order,
               " | volume=",DoubleToString(mresult.volume,2),
               " | price=",DoubleToString(mresult.price,_digits),
               " | bid=",DoubleToString(mresult.bid,_digits),
               " | ask=",DoubleToString(mresult.ask,_digits),
               " | comment=",mresult.comment,
               " | request_id=",mresult.request_id);
         return 1;
        }
      return 0;
     }
   return 1;
  }
//+------------------------------------------------------------------+
